// C Source File
// Created 07/08/2004; 14:27:49

#include <tigcclib.h>
#include "display.h"
#include "constants.h"
#include "tiles.h"


#define SHOW_FPS 0 // 0 : don't show, 1 : show fps
#define GAME_SPEED 10 // 0 : the fastest

INT_HANDLER OldInt1 = NULL;
#if SHOW_FPS == 1
char fpsStr[10];
#endif
char hwVersion;
volatile char quit = 0;
char modifying = 0;
char nextModif = 0;
short timeCount = 0;
volatile short fCount = 0;
void (*display_Modif)();

unsigned char * Buff;
unsigned char Plane = 0;
unsigned char * Plane0;
unsigned char * Plane1;
unsigned char * Plane00;
unsigned char * Plane10;
unsigned char * Plane01;
unsigned char * Plane11;
void Display();

// [Thanks to Geogeo from pws.tigen.org for this code]
#define __HARDWARE_FREQUENCY        20970 //256
static volatile unsigned short __COUNTER_HARDWARE=0;

DEFINE_INT_HANDLER (SceneModif)
{
  ExecuteHandler (OldInt1);
	//HARDWARE VERSION 1.0 
	if (hwVersion==1)
	{
		//Incrmentation
		__COUNTER_HARDWARE+=__HARDWARE_FREQUENCY;
	
		//Execution interrupotion
		if (__COUNTER_HARDWARE<=32768)
			return;
		//Remise  zro
		__COUNTER_HARDWARE-=32768;	      
	}
// [/Thanks to Geogeo from pws.tigen.org for this code]
	timeCount++;
	if (timeCount == (256))
	{
		timeCount = 0;
#if SHOW_FPS == 1
		DrawStr (0, 0, "          ", A_REPLACE);
		sprintf (fpsStr, "%u", fCount);
		DrawStr (0, 0, fpsStr, A_REPLACE);
#endif
		fCount = 0;
	}
	
	if (!modifying && !nextModif)
	{
		modifying = 1;
		nextModif = GAME_SPEED;
		display_Modif();
		modifying = 0;
	}
	if(nextModif)
		nextModif--;
}


void SetLoopFunc(void (*modifFunc)())
{
	display_Modif = modifFunc;
}


void LoopInit()
{
	quit = 0;
	modifying = 0;
	timeCount = 0;
	fCount = 0;
	hwVersion = HW_VERSION;
  OldInt1 = GetIntVec (AUTO_INT_1);
}

void LoopEnd()
{
  SetIntVec (AUTO_INT_1, OldInt1);	
}

void MainLoop()
{
  SetIntVec (AUTO_INT_1, SceneModif);
	while(!quit)
	{
		Display();
		fCount++;		
	}	
}

void LoopQuit()
{
	quit = 1;
}

void GetPlanes()
{
	Plane00 = (unsigned char *)GrayDBufGetHiddenPlane (DARK_PLANE);
	Plane10 = (unsigned char *)GrayDBufGetHiddenPlane (LIGHT_PLANE);
	
	GrayDBufToggle();

	Plane01 = (unsigned char *)GrayDBufGetHiddenPlane (DARK_PLANE);
	Plane11 = (unsigned char *)GrayDBufGetHiddenPlane (LIGHT_PLANE);

	GrayDBufToggle();
}

void GrayEnd()
{
  GrayOff ();
	free(Buff);
}
 
void DBufToggle()
{
	if(Plane)
	{
		Plane0 = Plane00;
		Plane1 = Plane10;
	}
	else
	{
		Plane0 = Plane01;
		Plane1 = Plane11;		
	}
	GrayDBufToggleSync();
	if(HW_VERSION == 1)
		GrayWaitNSwitches (2);
	Plane = 1 - Plane;
}

void GrayInit()
{
	Buff = (unsigned char *)calloc(GRAYDBUFFER_SIZE,1);
	GrayOn ();
	GrayDBufInit (Buff);
	GetPlanes();
	DBufToggle();
}

extern Tiles * t;
extern unsigned short dimX;
extern unsigned short dimY;
extern unsigned char * map;
extern unsigned short xmap;
extern unsigned short ymap;
unsigned short xmapi;
unsigned short ymapi;
extern unsigned char entry;
extern unsigned short tile;
extern unsigned short mode;
extern unsigned char menumode;
extern unsigned short xcursorstart;
extern unsigned short ycursorstart;
extern unsigned short xcursor;
extern unsigned short ycursor;
extern unsigned short dimxblock;
extern unsigned short dimyblock;
extern unsigned char * blok;
extern unsigned short sizex;
extern unsigned short sizey;
extern unsigned char sizeentry;

inline void drawcursor()
{
	static char cursorstyle = 0;
	short dxcursorstart2 = xcursorstart - xmapi;
	short dycursorstart2 = ycursorstart - ymapi;
	short dxcursor2 = xcursor - xmapi;
	short dycursor2 = ycursor - ymapi;
	short dxcursorstart;
	short dycursorstart;
	short dxcursor;
	short dycursor;

	PortSet (Plane0, 239, 127);

	dxcursorstart = dxcursorstart2;
	dycursorstart = dycursorstart2;
	dxcursor = dxcursor2;
	dycursor = dycursor2;
	if(dycursorstart >= 0 && dycursorstart < LARGY && dxcursorstart < LARGX && dxcursor >= 0)
	{
		if (dxcursorstart < 0) dxcursorstart = 0;
		if (dxcursor > LARGX - 1) dxcursor = LARGX - 1;
		DrawLine (dxcursorstart * t->tilesHeight + XOFFSET, dycursorstart * t->tilesHeight + YOFFSET, (dxcursor + 1) * t->tilesHeight + (XOFFSET-1), dycursorstart * t->tilesHeight + YOFFSET, cursorstyle);			
	}

	dxcursorstart = dxcursorstart2;
	dycursorstart = dycursorstart2;
	dxcursor = dxcursor2;
	dycursor = dycursor2;
	if(dycursor >= 0 && dycursor < LARGY && dxcursorstart < LARGX && dxcursor >= 0)
	{
		if (dxcursorstart < 0) dxcursorstart = 0;
		if (dxcursor > LARGX - 1) dxcursor = LARGX - 1;
		DrawLine (dxcursorstart * t->tilesHeight + XOFFSET, (dycursor + 1) * t->tilesHeight + (YOFFSET-1), (dxcursor + 1) * t->tilesHeight + (XOFFSET-1), (dycursor + 1) * t->tilesHeight + (YOFFSET-1), cursorstyle);
	}
	
	
	dxcursorstart = dxcursorstart2;
	dycursorstart = dycursorstart2;
	dxcursor = dxcursor2;
	dycursor = dycursor2;
	if(dxcursorstart >= 0 && dxcursorstart < LARGX && dycursorstart < LARGY && dycursor >= 0)
	{
		if (dycursorstart < 0) dycursorstart = 0;
		if (dycursor > LARGY - 1) dycursor = LARGY - 1;
		DrawLine (dxcursorstart * t->tilesHeight + XOFFSET, dycursorstart * t->tilesHeight + YOFFSET, dxcursorstart * t->tilesHeight + XOFFSET, (dycursor + 1) * t->tilesHeight + (YOFFSET-1), cursorstyle);
	}
	
	dxcursorstart = dxcursorstart2;
	dycursorstart = dycursorstart2;
	dxcursor = dxcursor2;
	dycursor = dycursor2;
	if(dxcursor >= 0 && dxcursor < LARGX && dycursorstart < LARGY && dycursor >= 0)
	{
		if (dycursorstart < 0) dycursorstart = 0;
		if (dycursor > LARGY - 1) dycursor = LARGY - 1;
		DrawLine ((dxcursor + 1) * t->tilesHeight + (XOFFSET-1), dycursorstart * t->tilesHeight + YOFFSET, (dxcursor + 1) * t->tilesHeight + (XOFFSET-1), (dycursor + 1) * t->tilesHeight + (YOFFSET-1), cursorstyle);
	}



	PortSet (Plane1, 239, 127);

	dxcursorstart = dxcursorstart2;
	dycursorstart = dycursorstart2;
	dxcursor = dxcursor2;
	dycursor = dycursor2;
	if(dycursorstart >= 0 && dycursorstart < LARGY && dxcursorstart < LARGX && dxcursor >= 0)
	{
		if (dxcursorstart < 0) dxcursorstart = 0;
		if (dxcursor > LARGX - 1) dxcursor = LARGX - 1;
		DrawLine (dxcursorstart * t->tilesHeight + XOFFSET, dycursorstart * t->tilesHeight + YOFFSET, (dxcursor + 1) * t->tilesHeight + (XOFFSET-1), dycursorstart * t->tilesHeight + YOFFSET, cursorstyle);			
	}

	dxcursorstart = dxcursorstart2;
	dycursorstart = dycursorstart2;
	dxcursor = dxcursor2;
	dycursor = dycursor2;
	if(dycursor >= 0 && dycursor < LARGY && dxcursorstart < LARGX && dxcursor >= 0)
	{
		if (dxcursorstart < 0) dxcursorstart = 0;
		if (dxcursor > LARGX - 1) dxcursor = LARGX - 1;
		DrawLine (dxcursorstart * t->tilesHeight + XOFFSET, (dycursor + 1) * t->tilesHeight + (YOFFSET-1), (dxcursor + 1) * t->tilesHeight + (XOFFSET-1), (dycursor + 1) * t->tilesHeight + (YOFFSET-1), cursorstyle);
	}
	
	
	dxcursorstart = dxcursorstart2;
	dycursorstart = dycursorstart2;
	dxcursor = dxcursor2;
	dycursor = dycursor2;
	if(dxcursorstart >= 0 && dxcursorstart < LARGX && dycursorstart < LARGY && dycursor >= 0)
	{
		if (dycursorstart < 0) dycursorstart = 0;
		if (dycursor > LARGY - 1) dycursor = LARGY - 1;
		DrawLine (dxcursorstart * t->tilesHeight + XOFFSET, dycursorstart * t->tilesHeight + YOFFSET, dxcursorstart * t->tilesHeight + XOFFSET, (dycursor + 1) * t->tilesHeight + (YOFFSET-1), cursorstyle);
	}
	
	dxcursorstart = dxcursorstart2;
	dycursorstart = dycursorstart2;
	dxcursor = dxcursor2;
	dycursor = dycursor2;
	if(dxcursor >= 0 && dxcursor < LARGX && dycursorstart < LARGY && dycursor >= 0)
	{
		if (dycursorstart < 0) dycursorstart = 0;
		if (dycursor > LARGY - 1) dycursor = LARGY - 1;
		DrawLine ((dxcursor + 1) * t->tilesHeight + (XOFFSET-1), dycursorstart * t->tilesHeight + YOFFSET, (dxcursor + 1) * t->tilesHeight + (XOFFSET-1), (dycursor + 1) * t->tilesHeight + (YOFFSET-1), cursorstyle);
	}

	cursorstyle = 1 - cursorstyle;

}

inline void drawhud()
{
	clrscr();
	DrawLine (0, 0, SCR_WIDTH, 0, A_NORMAL);
	switch (mode)
	{
		case 0:
			DrawStr (0, 2, "Tiles  Select    Save    Reload    Size    ?    Quit", A_NORMAL);
			break;
		case 1:
			DrawStr (0, 2, "Tiles   Single    Save    Reload    Size    ?    Quit", A_NORMAL);
			break;
		case 2:
			DrawStr (0, 2, "Tiles   Block     Save    Reload    Size    ?    Quit", A_NORMAL);
			break;
		default:;
	}
	DrawLine (0, 44, 17, 44, A_NORMAL);
	DrawLine (0, 45, 17, 45, A_NORMAL);
	DrawLine (0, 62, 17, 62, A_NORMAL);
	DrawLine (0, 63, 17, 63, A_NORMAL);
	DrawLine (0, 8, SCR_WIDTH, 8, A_NORMAL);
	DrawLine (0, SCR_HEIGHT, SCR_WIDTH, SCR_HEIGHT, A_NORMAL);
	DrawLine (0, 0, 0, SCR_HEIGHT, A_NORMAL);
	DrawLine (SCR_WIDTH, 0, SCR_WIDTH, SCR_HEIGHT, A_NORMAL);
	DrawLine (17, 0, 17, SCR_HEIGHT, A_NORMAL);
	
}

inline void drawtile(short num, short x, short y, short all)
{
	if (t->tilesWidth == 1)
	{
		if (all) 
		{
			Sprite8 (x, y, t->tilesHeight, t->tiles + t->tilesHeight * t->tilesWidth * t->nbPlanes * num, Plane0, SPRT_AND); 
			Sprite8 (x, y, t->tilesHeight, t->tiles + t->tilesHeight * t->tilesWidth * t->nbPlanes * num, Plane0, SPRT_OR); 
		}
		Sprite8 (x, y, t->tilesHeight, t->tiles + t->tilesHeight * t->tilesWidth * (t->nbPlanes * num + 1), Plane1, SPRT_AND);
		Sprite8 (x, y, t->tilesHeight, t->tiles + t->tilesHeight * t->tilesWidth * (t->nbPlanes * num + 1), Plane1, SPRT_OR);
	}
	else
	{
		if (all)
		{
			Sprite16 (x, y, t->tilesHeight, (unsigned short *)((t->tiles) + (t->tilesWidth * t->tilesHeight * num * t->nbPlanes)), Plane0, SPRT_AND); 
			Sprite16 (x, y, t->tilesHeight, (unsigned short *)((t->tiles) + (t->tilesWidth * t->tilesHeight * num * t->nbPlanes)), Plane0, SPRT_OR); 
		}
		Sprite16 (x, y, t->tilesHeight, (unsigned short *)((t->tiles) + (t->tilesWidth * t->tilesHeight * (num * t->nbPlanes + 1))), Plane1, SPRT_AND); 
		Sprite16 (x, y, t->tilesHeight, (unsigned short *)((t->tiles) + (t->tilesWidth * t->tilesHeight * (num * t->nbPlanes + 1))), Plane1, SPRT_OR); 
	}
}

inline void drawtiles()
{
	register unsigned short i;
	
	for(i = 0; i<5; i++)
		if (((signed short)(tile - 2 + i) >= 0) && ((tile - 2 + i) < (t->nbTiles)))
			drawtile(tile - 2 + i, 1, i * (t->tilesHeight + 2) + 10, (i == 2));
}

void fillrect(short x0, short y0, short x1, short y1, short Attr)
{
	register short i;
	for (i = y0; i <= y1; i++)
		DrawLine (x0, i, x1, i, Attr);		
}

inline void drawmap()
{
	register unsigned short i,j;
	for (i=0;i<LARGX;i++)
	{
		for(j= 0; j<LARGY;j++)
		{
			if ((i + xmapi) <dimX && (j + ymapi) < dimY)
				drawtile(map[(i + xmapi)+(j + ymapi)*dimX], XOFFSET + i * t->tilesHeight, j * t->tilesHeight + YOFFSET, 1);
		}
	}
}

void drawblock()
{
	register unsigned short i,j;
	for (i=0;i<LARGX;i++)
	{
		for(j= 0; j<LARGY;j++)
		{
			if ((((i + xmapi) >= xcursorstart) && ((i + xmapi) < xcursor+1)) && (((j + ymapi) >= ycursorstart) && ((j + ymapi) < ycursor+1)))
				drawtile(blok[(i + xmapi - xcursorstart)+(j + ymapi - ycursorstart)*dimxblock], XOFFSET + i * t->tilesHeight, j * t->tilesHeight + YOFFSET, 1);
		}
	}
}

inline void DrawFrame()
{
	char string[20];
	xmapi = xmap;
	ymapi = ymap;
	
	PortSet (Plane0, 239, 127);
	drawhud();
	PortSet (Plane1, 239, 127);
	drawhud();

	drawtiles();

	drawmap();
	
	if (menumode)
	{
		switch (entry)
		{
			case 0:
				PortSet (Plane0, 239, 127);
				fillrect(1,1,16,7, A_XOR);
				PortSet (Plane1, 239, 127);
				fillrect(1,1,16,7, A_REVERSE);
				break;
			case 1:
				PortSet (Plane0, 239, 127);
				fillrect(18,1,46,7, A_XOR);
				PortSet (Plane1, 239, 127);
				fillrect(18,1,46,7, A_REVERSE);
				break;
			case 2:
				PortSet (Plane0, 239, 127);
				fillrect(47,1,69,7, A_XOR);
				PortSet (Plane1, 239, 127);
				fillrect(47,1,69,7, A_REVERSE);
				break;
			case 3:
				PortSet (Plane0, 239, 127);
				fillrect(70,1,101,7, A_XOR);
				PortSet (Plane1, 239, 127);
				fillrect(70,1,101,7, A_REVERSE);
				break;
			case 4:
				PortSet (Plane0, 239, 127);
				fillrect(102,1,124,7, A_XOR);
				PortSet (Plane1, 239, 127);
				fillrect(102,1,124,7, A_REVERSE);
				break;
			case 5:
				PortSet (Plane0, 239, 127);
				fillrect(125,1,135,7, A_XOR);
				PortSet (Plane1, 239, 127);
				fillrect(125,1,135,7, A_REVERSE);
				break;
			case 6:
				PortSet (Plane0, 239, 127);
				fillrect(136,1,159,7, A_XOR);
				PortSet (Plane1, 239, 127);
				fillrect(136,1,159,7, A_REVERSE);
				break;
			default:;
		}
		if (menumode == 2)
		{
			PortSet (Plane0, 239, 127);
			fillrect(102,9,130,26, A_NORMAL);
			sprintf (string, "X : %u", sizex);
			DrawStr (103, 11, string, A_REVERSE);
			sprintf (string, "Y : %u", sizey);
			DrawStr (103, 20, string, A_REVERSE);
			PortSet (Plane1, 239, 127);
			fillrect(102,9,130,26, A_REVERSE);
			fillrect(102,9 + sizeentry * 9 ,130,17 + sizeentry * 9 , A_NORMAL);
		}
		if (menumode == 3)
		{
			PortSet (Plane0, 239, 127);
			fillrect(35,9,135,37, A_NORMAL);
			
			DrawStr (68, 11, "About", A_REVERSE);
			DrawStr (36, 19, "Map Editor", A_REVERSE);
			DrawStr (36, 27, "2004 By Lionel Anton", A_REVERSE);

			PortSet (Plane1, 239, 127);
			fillrect(35,9,135,37, A_REVERSE);
		}
	}
	else
	{
		if (mode == 2)
			drawblock();
		drawcursor();
	}
}

void Display()
{
	DrawFrame();
	DBufToggle();
}
