// C Source File
// Created 07/08/2004; 14:24:15

#include <tigcclib.h>
#include "display.h"
#include "kbd.h"
#include "game.h"
#define ARCHNAME "fzerogfx"

unsigned char mapname[20];
unsigned char tilename[20];
unsigned char tileselname[20];
unsigned short dimX;
unsigned short dimY;
unsigned char * map;


// Main Function
void _main(void)
{
	register unsigned short i;
	ESI argptr;
	int argtype;
	FILE * mapFile;
	map = NULL;
	
	
	InitArgPtr (argptr);
	if ((argtype = GetArgType (argptr)) == END_TAG)
		return;
	if (argtype != STR_TAG)
		return;
	strncpy (tilename, GetStrnArg (argptr), 19);
	tilename[19] = 0;
	
	if (SymFind (SYMSTR (tilename)).folder == 0)
	{
		ST_helpMsg ("tile file not found");
		ngetchx();
		return;
	}

	if ((argtype = GetArgType (argptr)) == END_TAG)
		return;
	if (argtype != STR_TAG)
		return;
	strncpy (tileselname, GetStrnArg (argptr), 19);
	tileselname[19] = 0;
	
	if (SymFind (SYMSTR (tileselname)).folder == 0)
	{
		ST_helpMsg ("tile selection file not found");
		ngetchx();
		return;
	}

	if ((argtype = GetArgType (argptr)) == END_TAG)
		return;
	if (argtype != STR_TAG)
		return;
	strncpy (mapname, GetStrnArg (argptr), 19);
	mapname[19] = 0;

	if ((mapFile = fopen (mapname, "rb")) != NULL)
	{
		fread (&(dimX), sizeof(short), 1, mapFile); 
		fread (&(dimY), sizeof(short), 1, mapFile);
		map = (unsigned char *)malloc(sizeof(unsigned char) * dimX * dimY);
		
		for(i=0;i < (dimX * dimY);i++)
		{
			fread (&(map[i]), sizeof(char), 1, mapFile);
		}
		fclose (mapFile);
	}
	else
	{
		dimX = 0;
		dimY = 0;
	}
	
// inits
	kbd_Init();
	clrscr();
	GrayInit();

	FontSetSys(F_4x6);
	game();
	
	for(;ENTER;kbd_Scan());
	GrayEnd();
	kbd_End();
	PortRestore();
	clrscr();
	if (map)
		free(map);
}
