// C Source File
// Created 13/03/2004; 10:19:46

#include "tiles.h"

Tiles * TilesLoad(const char * tilesFileName, const char * tilesSelectionFileName)
{
	register unsigned short i, j, k;
	Tiles * tiles;
	FILE * tilesFile;
	FILE * selFile;
	unsigned short nbTiles, nbRanges;
	unsigned char byte, * offset, * ranges, * tilesnum;
	tilesFile = fopen(tilesFileName, "rb");
	selFile = fopen(tilesSelectionFileName, "rb");

	tiles = (Tiles*)malloc(sizeof(Tiles));
	fread (&(tiles->nbPlanes), sizeof(short), 1, tilesFile);
	fread (&nbTiles, sizeof(short), 1, tilesFile);
	fread (&nbTiles, sizeof(short), 1, selFile);
	fread (&nbRanges, sizeof(short), 1, selFile);
	tiles->nbTiles = nbTiles;
	
	fread (&(tiles->tilesWidth), sizeof(short), 1, tilesFile);
	fread (&(tiles->tilesHeight), sizeof(short), 1, tilesFile);

	ranges = (unsigned char *)malloc(sizeof(unsigned char *) * nbRanges * 2);
	tilesnum = (unsigned char *)malloc(sizeof(unsigned char *) * nbTiles);
	for(i=0;i<nbRanges;i++)
	{
		fread (&(ranges[i * 2]), sizeof(unsigned char), 1, selFile);
		fread (&(ranges[(i * 2)+1]), sizeof(unsigned char), 1, selFile);
	}
	fclose(selFile);

	k = 0;
	for(i=0;i<nbRanges;i++)
	{
		for(j=ranges[i * 2]; j <= ranges[(i * 2)+1]; j++)
			tilesnum[k++] = j;
	}
	free(ranges);


	if (tiles->nbPlanes == 2)
		nbTiles <<= 1;

	tiles->tiles = (unsigned char *)malloc(sizeof(unsigned char) * tiles->tilesWidth * tiles->tilesHeight * nbTiles);


	offset = tiles->tiles;

	for (i=0; i < tiles->nbTiles; i++)
	{
		fseek(tilesFile, 8 + (tilesnum[i] * tiles->tilesWidth * tiles->tilesHeight * tiles->nbPlanes), SEEK_SET);
		for(j=0; j < (tiles->tilesWidth * tiles->tilesHeight * tiles->nbPlanes); j++)
		{
			fread (&byte, sizeof(unsigned char), 1, tilesFile);
			*offset = byte;
			offset++;			
		}
	}

	free(tilesnum);

	fclose(tilesFile);
	
	return tiles;
}

void TilesFree(Tiles * tiles)
{
	free(tiles->tiles);
	free(tiles);
}
