// C Header File
// Created 13/03/2004; 10:19:39

#ifndef MAP_H
#define MAP_H

#include <tigcclib.h>         // Include All Header Files
#include "defines.h"
#include "arch.h"

#if ENABLE_GRAYSCALE == 1
typedef struct Map
{
	unsigned short dimX;
	unsigned short dimY;
	unsigned char * map;
	unsigned char * map0;
	unsigned char * map1;
}Map;

#else
typedef struct Map
{
	unsigned short dimX;
	unsigned short dimY;
	unsigned char * map;
	unsigned char * map0;
}Map;
#endif

Map * map_Load(ARCH * archmap, ARCH * archtile, const char * mapFileName, const char * tilesFileName);
void map_Free(Map * map);

#if ENABLE_LARGE_MAPS == 2

typedef struct Tiles
{
	unsigned short nbPlanes;
	unsigned short tilesWidth;
	unsigned short tilesHeight;
	unsigned char * tiles;	
}Tiles;

typedef struct ExtraMap
{
	unsigned short dimX;
	unsigned short dimY;
	unsigned char ** maptiles;
	unsigned char * map;
	Tiles * tiles;
}ExtraMap;

Tiles * map_TilesLoad(ARCH * arch, const char * tilesFileName, const char * tilesSelectionFileName);
void map_TilesFree(Tiles * tiles);
ExtraMap * map_XMapLoad(ARCH * arch, const char * mapFileName, Tiles * tiles);
void map_XMapFree(ExtraMap * map);
#endif


#endif
