// C Header File
// Created 04/02/2004; 09:47:19

#ifndef MODE7_H
#define MODE7_H

#include "defines.h"
#include "map.h"
#include "m7sprites.h"

extern signed char CosTable[NBDIR];	// contains cos values (useful for faster calculus)
extern signed char SinTable[NBDIR];	// contains sin values
extern short Dir;	// camera direction
extern unsigned char * MapData;
extern short DimX;
extern short DimY;

#if ENABLE_GRAYSCALE == 1
extern unsigned char * Plane0;
extern unsigned char * Plane1;
#else
extern char Virtual[3000];
#endif

// inits
void m7_Init(short SizeHorz, short ViewL, short ViewF);
	// SizeHorz: nb of times that the up is larger than the bottom ?? (try 8)
	// ViewL: angle of view ?? (try 60)
	// ViewF: front distance ?? (try 30)
void m7_ReInit(short SizeHorz, short ViewL, short ViewF);
void m7_End();
#if ENABLE_MORE_DISPLAY == 1
void m7_InitMoreDisplay(void (*moreDispFunc)());
#endif
#if ENABLE_LARGE_MAPS == 2
void m7_SetMap(ExtraMap * m);	// init of map
#else
void m7_SetMap(Map * m);	// init of map
#endif
#if ENABLE_GRAYSCALE == 1
void m7_GrayInit();	// initialization for grayscale (call it after a keyboard init)
void m7_GrayEnd();	// end grayscale (call it before a keyboard ending)
void m7_DBufToggle(); // toggles hidden and active planes
void m7_SetSky(unsigned char *sky0, unsigned char *sky1); // init of sky
#else
void m7_SetSky(unsigned char *sky); // init of sky
#endif

// transformations
void m7_LoadIdentity();	// reset position and angle
void m7_Rotate(short angle);	// rotate of angle (specified in number of subdivision previously defined)
void m7_SetDir(unsigned short dir); // set the direction of the camera
void m7_LookAt(short x, short y); // look in the direction of the point (x,y)
void m7_TranslateXY(short x, short y);	// translate x and y position
void m7_TranslateDir(short dist);	 // translate dist in the current direction
void m7_SetCameraPos(short x, short y); // set the camera at (x << SINCOS,y << SINCOS) real coords
void m7_SetCameraPos2(short x, short y); // set the camera at (x,y)
void m7_GetCameraPos(short * x, short * y); // get the camera position (x,y)

// display loop
void m7_SetLoopFunc(void (*modifFunc)()); // call m7_LoopQuit() inside modifFunc to break the loop
void m7_LoopInit();
void m7_MainLoop();
void m7_LoopQuit();
void m7_LoopEnd();

#endif
